( function( $ ) {

	$( function() {
		// add new script field
		$( document ).on( 'click', '.add-custom-script-field', function( e ) {
			e.preventDefault();

			// add script field
			$( this ).before( '<div class="custom-script-field" style="display: none;">' + $( '#custom-script-field-template' ).html() + '</div>' );

			// get last script field and display it
			$( this ).parent().find( '.custom-script-field' ).last().fadeIn( 300 );
		} );

		// remove custom script field
		$( document ).on( 'click', '.remove-custom-script-field', function( e ) {
			e.preventDefault();

			// find closest script and remove it
			$( this ).closest( '.custom-script-field' ).fadeOut( 300, function() {
				$( this ).remove();
			} );
		} );

		// add new iframe field
		$( document ).on( 'click', '.add-custom-iframe-field', function( e ) {
			e.preventDefault();

			// add iframe field
			$( this ).before( '<div class="custom-iframe-field" style="display: none;">' + $( '#custom-iframe-field-template' ).html() + '</div>' );

			// get last iframe field and display it
			$( this ).parent().find( '.custom-iframe-field' ).last().fadeIn( 300 );
		} );

		// remove custom iframe field
		$( document ).on( 'click', '.remove-custom-iframe-field', function( e ) {
			e.preventDefault();

			// find closest iframe and remove it
			$( this ).closest( '.custom-iframe-field' ).fadeOut( 300, function() {
				$( this ).remove();
			} );
		} );

		$(document).on('change', '.native-script-blocking', function(e) {
			var shouldShowFields = $(this).prop("checked");
			var formGroup = $('.native-script-blocking-dependency').closest('.form-group');

			if (shouldShowFields) {
				formGroup.fadeIn(300);
			} else {
				formGroup.fadeOut(300);
			}
		});

		// Trigger the change event for .native-script-blocking
		$('.native-script-blocking').change();

		$('.autoblocking-status').prop('disabled', true);

		$(document).ready(function() {
			$('.autoblocking-status').each(function() {
				let checkbox = $(this);

				// Get the name attribute of the current checkbox
				let name = checkbox.attr('name');

				// Replace 'IUBENDA_AUTOBLOCK_STATUS' with 'IUBENDA_CODE' to generate the target
				let target = name.replace('IUBENDA_AUTOBLOCK_STATUS', '#IUBENDA_CODE');
				let ajaxRequestTimeout; // Variable to store the timeout
				let isAjaxRequestInProgress = false; // Flag to track AJAX request status

				// Function to handle AJAX request with delay
				function checkAutoblockingStatus() {
					let script = $(target).val();

					if (isAjaxRequestInProgress) {
						return;
					}

					// Set the flag to indicate that an AJAX request is in progress
					isAjaxRequestInProgress = true;

					// Prepare data to send in the AJAX request
					var dataToSend = {
						ajax: true,
						action: 'checkAutoblockingStatus',
						format: 'json',
						toke : token,
						script: script,
					};

					// AJAX request to check auto block status
					$.ajax({
						type: 'POST',
						cache: false,
						dataType: 'json',
						data: dataToSend,
						success: function(response) {
							if (response) {
								checkbox.prop("checked", response);
								checkAndDisplayWarning()
							} else {
								checkbox.prop("checked", false);
								checkAndDisplayWarning()
							}
						},
						error: function() {
							checkbox.prop("checked", false);
							checkAndDisplayWarning()
						},
						complete: function() {
							// Reset the flag when the AJAX request is complete
							isAjaxRequestInProgress = false;

							// Handle warning section
							checkAndDisplayWarning()
						}
					});
				}

				// Attach event handlers for keyup and change
				$(target).on('keyup change', function() {
					clearTimeout(ajaxRequestTimeout); // Clear previous timeout
					ajaxRequestTimeout = setTimeout(checkAutoblockingStatus, 1000);
				});

				// Perform the check immediately after document is ready
				checkAutoblockingStatus();

				// Function to handle the visibility of the warning section
				function checkAndDisplayWarning(){
					let allChecked = true;
					let checkboxes = $('.autoblocking-status'); // Cache the selector for performance

					checkboxes.each(function() {
						if (!$(this).prop('checked')) { // Using .prop() for checkbox state
							allChecked = false;
							return false; // Break the loop
						}
					});

					let warningSection = $('.iubenda-autoblocking-warning-section')
					let infoSection = $('.iubenda-autoblocking-info-section')

					if (allChecked) {
						warningSection.hide();
						infoSection.show();
					} else {
						warningSection.show();
						infoSection.hide();
					}
				}
			});
		});

	} );

} )( jQuery );
